/*
01
Program si vyzada vstup, vypise mapu. Algoritmus na vyhledani cesty je trochu 
upraveny algoritmus na prohledavani grafu do hloubky. Na zacatku kazdeho kroku
vybere z fronty bod, najde vsechny jeho sousedy a pokud neni delka cesty pres 
tento vrchol delsi nez ta puvodni, prida ho do fronty. Zaroven si u kazdeho bodu
pamatuje, odkud jsme k nemu dosli. Na zacatku je ve fronte start, algoritmus 
pokracuje dokud neni fronta prazdna. Pote si od cile projde cestu zpatky
*/

#include <cstdlib>
#include <iostream>
#include <fstream>
#include <math.h>
using namespace std;

struct povel{
       public:
              int x,y;       
};

struct bod{
       public:
              int x,y,prBod;
              povel prijezd;
              unsigned long vzdalenost;
              bool operator!=(const bod &rhs){
                   if (rhs.x!=x || rhs.y!=y) return true;
                   else return false;   
              }
};

int main(int argc, char *argv[]) {
    char mapa[255][255];
    int  x=0, y, i, j, pocetB=0, pocetC=0;
    bod start, cil[2];
    cil[1].vzdalenost=0;
    
// 1. cast
    for (i=0;i<255;i++){
        mapa[0][i]='Y';    
    }   // inicializujeme 1. radek pole, kvuli zjisteni sirky mapy
    ifstream fin;
    char filename[255];
    mapa:
    cout << "zadejte jmeno souboru s mapou:";
    cin >> filename;
    fin.open(filename);
    i=0;
    while (fin >> mapa[i]){
          i++;
          x++;      
    }               // nacteme mapu, zjistime jeji delku
    for (i=0;i<255;i++){
        if (mapa[0][i]=='Y'){
           y=i-2;
           break;                               
        }    
    }                        // zjistime sirku mapy;
    for (i=0;i<x;i++){
        for (j=0;j<y;j++){
            if (!(mapa[i][j]=='X' || mapa[i][j]==':' || mapa[i][j]=='.' || mapa[i][j]=='S'
             || mapa[i][j]=='C' || mapa[i][j]=='\0')){
               cout << "soubor s mapou je spatny \"" << mapa[i][j] << "\"" << i << " " << j << endl;
               goto mapa;                      
            }
            if (mapa[i][j]==':' || mapa[i][j]=='.' || mapa[i][j]=='S' || mapa[i][j]=='C'){
               pocetB++;                    
            }                           
            if (mapa[i][j]=='S'){
               start.x=i;
               start.y=j;       
               start.prijezd.x=0;
               start.prijezd.y=0;
               start.vzdalenost=0;
            }
            if (mapa[i][j]=='C'){
               if (cil[0].vzdalenost==0){
                  cil[0].x=i;
                  cil[0].y=j;    
                  cil[0].vzdalenost=-1;                      
               }
               cil[1].x=i;
               cil[1].y=j;  
            }
        }    
    } // zjistime korektnost mapy, zaznamename si nekt. informace o mape
    cil[1].vzdalenost=-1;
    for (i=0;i<x;i++){
        cout << mapa[i] << endl;    
    } // vypiseme mapu
    fin.close();
    
// 2. cast

    bod b[pocetB];
    int iB=1,body[x][y];
    b[0]=start;
    body[start.x][start.y]=0;
    for (i=0;i<x;i++){
        for (j=0;j<y;j++){
            if (mapa[i][j]=='.' || mapa[i][j]==':' || mapa[i][j]=='C') {
               b[iB].x=i;
               b[iB].y=j;
               b[iB].vzdalenost=-1;
               body[i][j]==iB;
               iB++;      
            }    
            else {
                 body[i][j]==-1;
            }
        }    
    } // naplnime pole s body
    povel aktualni;
    int fronta[pocetB],zI=0,kI=0; // frotna pro body, zacatecni a konecny index
    fronta[zI]=0;
    bool sousedi[pocetB]; // sousedi aktualniho bodu
    unsigned long vzdalenost=-1;
    while (kI>zI){
          for (i=0;i<pocetB;i++){
              sousedi[i]=false;
          } // odstranime sousedy predchoziho bodu
          aktualni=b[fronta[zI]].prijezd;
          aktualni.x=aktualni.x-2;
          aktualni.y=aktualni.y-2;
          for (i=0;i<3;i++){
              aktualni.x++;
              for (j=0;j<3;j++){
                  aktualni.y++;
                  if (body[b[fronta[zI]].x+aktualni.x][b[fronta[zI]].y+aktualni.y]!=-1){
                     sousedi[body[b[fronta[zI]].x+aktualni.x][b[fronta[zI]].y+aktualni.y]]=true;
                  }
              }
          }// zjistime body do kterych muzeme jet
          
          for (i=0;i<pocetB;i++){
              if (sousedi[i]){
                 if (b[i].vzdalenost < b[fronta[zI]].vzdalenost+1){
                    fronta[kI]=i;      
                    b[i].vzdalenost=b[fronta[zI]].vzdalenost+1;
                    b[i].prijezd.x=abs(b[fronta[zI]].x-b[i].x);
                    b[i].prijezd.y=abs(b[fronta[zI]].y-b[i].y);
                    b[i].prBod=fronta[zI];
                    kI++;          
                 }
              }    //pridame je do fronty a zapiseme predchudce
          }
          zI++;// a odstranime puvodni vchol z fronty
    }
    for (i=cil[0].x;i<cil[1].x;i++){
        for (j=cil[0].y;j<cil[1].y;j++){
            if (b[body[i][j]].vzdalenost<cil[0].vzdalenost){
               cil[0]=b[body[i][j]];                                                
            }
        }                           
    }
    povel povely[cil[0].vzdalenost];
    bod tmp=cil[0];
    i=cil[0].vzdalenost-1;
    do {
       povely[i]=tmp.prijezd;
       i--;
       tmp=b[tmp.prBod];
    }while(start!=tmp);
    ofstream fout;
    cout << "zadejte jmeno vystupniho souboru:";
    cin >> filename;
    fout.open(filename);
    for (i=0;i<cil[0].vzdalenost;i++){
        fout << povely[i].x << "," << povely[i].y << endl;  
    }
    fout.close();
    system("PAUSE");
    return EXIT_SUCCESS;
}
